# ECC-RAM

Electronic Chamber Choir - Random Access Music

## Basic Idea

The ECC is a swarm of independent small devices (called "singers") which perform
a piece of music together.

### Initial state

When the ECC starts (or as been freshly reset) every singer randomly chooses a
voice out of the "score" (probably a voice out of a MIDI-file) at a random
position and starts singing.

### Synchronisation

Every singer has, apart from his main audio autput (loudspeaker or piezo), also
an supersonic sender/receiver facility over which he sends what he is currently
singing and tries to listen to other singers trying to broadcast their position.
Over this supersonic interface now the singers try to synchronise themselves
while still singing, preferably starting with adjusting to direct neighbours
forming local clusters and then the clusters trying to synchronise each other.

Once synchronisation is complete, the piece of music performed will be audible
in all its aspects.

### Resetting

Every singer has a photosensitive element on them, which can react to sudden
changes in lighting conditions (e.g. when exposed to a camera flash). When
triggerd, avery singer affected resets and begins at a new initial state.

apart from this there can also be other ways of resetting single choir members
or the whole choir.
